--LIBRARIES
local gui = require "gui"
local anim8 = require "anim8"
--HELPER FUNCTIONS TO REmAKE THE OL window.getWidth / getHeight
function love.window.getHeight()
   local _, h = love.window.getMode()
   return h
end

function love.window.getWidth()
   local w = love.window.getMode()
   return w
end
--CALLBACKS
function love.load ()
  love.graphics.setDefaultFilter("nearest", "nearest")
  local font = love.graphics.newImageFont("bitfont.png","!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_`´abcdefghijklmnopqrstuvwxyz{|} ",-1)
  love.graphics.setFont(font)
  --CREATE BUTTONIMAGES
  buttoncornerON = love.graphics.newImage("buttoncornerON.png")
  buttoncorner = love.graphics.newImage("buttoncorner.png")
  buttonedgeON = love.graphics.newImage("buttonedgeON.png")
  buttonedge = love.graphics.newImage("buttonedge.png")
  buttoncenter = love.graphics.newImage("buttoncenter.png")
  --CREATE ANIMATION FOR THE CORNERS
  buttoncornerONgrid = anim8.newGrid(9,9,buttoncornerON:getWidth(),buttoncornerON:getHeight())
  buttoncornerONanimation= anim8.newAnimation(buttoncornerONgrid('1-4',1),0.3,"pauseAtEnd")
  --CREATE A SYSTEM FOR THE BUTTONS TO USE(includes all the images and animations)
  buttonsystem = newButtonSystem(buttoncenter,buttonedge,buttoncorner,buttoncenter,buttonedgeON,{a=buttoncornerONanimation,b=buttoncornerON})
  --CREATE 2 BUTTONS ONE FOR QUITTING AND THE OTHER ONE JUST PRINTS OUT "test"
  quit = newButton("QUIT",love.window.getWidth()/2,love.window.getHeight()/2,100,100,50,50,function() love.event.push("quit") end,buttonsystem)
  test = newButton("TEST",love.window.getWidth()/2,love.window.getHeight()/2 - 120,100,100,50,50,function() print "test" end,buttonsystem)
end

function love.draw()
   --DRAWS BUTTONS
   quit:draw()
   test:draw()
end

function love.update(dt)
   --NOW IT SHOULD UPDATE THE BUTTONS(i.g. the animations of the buttonparts)
   quit:update(dt)
   test:update(dt)
end

function love.mousepressed(x,y)
   --TESTS IF THE BUTTON IS cLICKED
   quit:mousepressed(x,y)
   test:mousepressed(x,y)
end
